// CGMScriptDoc.cpp : implementation of the CCGMScriptDoc class
//

#include "stdafx.h"
#include "CGMScript.h"

#include "Foreman.h"
#include "CGMScriptDoc.h"
#include "Task.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// This is a global volatile declaration for the thread to check.
int volatile g_nCount;

/////////////////////////////////////////////////////////////////////////////
// CCGMScriptDoc

IMPLEMENT_DYNCREATE(CCGMScriptDoc, CDocument)

BEGIN_MESSAGE_MAP(CCGMScriptDoc, CDocument)
	//{{AFX_MSG_MAP(CCGMScriptDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCGMScriptDoc construction/destruction

CCGMScriptDoc::CCGMScriptDoc()
{
	// TODO: add one-time construction code here
	TRACE("CGMScriptDoc ctor\n");
#ifdef _DEBUG
	afxDump.SetDepth(0);	// Ensures dumping of elements in CObArray
#endif _DEBUG
	m_Foreman.SetDocument(this);
}

/////////////////////////////////////////////////////////////////////////////
// CCGMScriptDoc serialization

void CCGMScriptDoc::Serialize(CArchive& ar)
{
	TRACE("CGMScriptDoc Serialize ");
	if (ar.IsStoring())
	{
		TRACE("Storing \n");
	}
	else
	{
		TRACE("Loading \n");
	}
	// Last, the array of CMFElem derived objects is serialized
	m_ElemArray.Serialize(ar);
}

/////////////////////////////////////////////////////////////////////////////
// CCGMScriptDoc diagnostics

#ifdef _DEBUG
void CCGMScriptDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CCGMScriptDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
	dc << "\n" << m_ElemArray;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCGMScriptDoc commands

BOOL CCGMScriptDoc::OnSaveDocument(LPCTSTR lpszPathName) 
{
	m_Foreman.ClearDocument();				// Clear Undo list	
	return CDocument::OnSaveDocument(lpszPathName);
}

void CCGMScriptDoc::DeleteContents() 
{
	// This member function is called by several message handlers
	// and indirectly by the FrameWork to reset the document, in 
	// OnNewDocument, OnClearAll etc...
	int i=0;
#ifdef _DEBUG
	Dump(afxDump);	// Check to see what's in the array.
#endif
	for(i=0;i<m_ElemArray.GetSize();i++)
		delete m_ElemArray[i];				// Empty CMFElem Array
	m_ElemArray.RemoveAll();				// Reset Array Size.
	m_Foreman.ClearDocument();				// Clear Undo list
	// This section clears the global variable list.
	POSITION pos = m_VarList.GetHeadPosition();
	while (pos != NULL)	{
		CMacro* p;
		p = (CMacro *) m_VarList.RemoveHead();
		delete p;
		pos = m_VarList.GetHeadPosition();
	}
}

// Finds a global variable by name. Returns a pointer to it if found.
CMacro* CCGMScriptDoc::FindByName(const char *text,int len)
{
	if (!m_VarList.IsEmpty()) {
		CMacro* var;
		POSITION pos = m_VarList.GetHeadPosition();
		while (pos != NULL) {
			var = (CMacro *) m_VarList.GetNext(pos);
			if (!strncmp(var->get_name(),text,len))
				return var;
		}
		return NULL;	// Not found
	}
	else return NULL;	// Not found
}

long* CCGMScriptDoc::GetLongsFromFile(CString s_file,long &count) {
	char buf[LINE_LEN+1];
	long pos,ind,len;
	char *ps,*pe;
	CFile file;
	CMacro exp;
	long *values=NULL;

	VERIFY(file.Open(s_file,CFile::modeRead));
	buf[LINE_LEN] = '\0';
	// Read the file by chunks. LINE_LEN is the max len accepted by the parser. 
	// Look for semicolon, newline or tab as separators.
	do { 
		ind = 0;
		len = file.Read(buf,LINE_LEN);
		ps = buf-1;
		do {
			if ((count % 1024) == 0) {	// chunk is full or empty
				// Realloc 1024 more
				realloc(values,(size_t) (count+1024)*(sizeof(long)));
			}
			pe = ps+1;					// ready for next expression
			pos = strcspn(pe,";\t\n");
			ps = pe+pos;
			*ps = '\0';					// sets separator to null term.
			ind = ind + pos +1;
			exp.set_string(pe);			// set macro string to pe-ps
			values[count] = (long) exp.resolve(this);
			count++;
		} while (ind < len);
	} while (len == LINE_LEN);
	file.Close();
	return values;
}

float* CCGMScriptDoc::GetFloatsFromFile(CString s_file,long &count) {
	char buf[LINE_LEN+1];
	long pos,ind,len;
	char *ps,*pe;
	CFile file;
	CMacro exp;
	float *values=NULL;

	VERIFY(file.Open(s_file,CFile::modeRead));
	buf[LINE_LEN] = '\0';
	// Read the file by chunks. LINE_LEN is the max len accepted by the parser. 
	// Look for semicolon, newline or tab as separators.
	do { 
		ind = 0;
		len = file.Read(buf,LINE_LEN);
		ps = buf-1;
		do {
			if ((count % 1024) == 0) {	// chunk is full or empty
				// Realloc 1024 more
				realloc(values,(size_t) (count+1024)*(sizeof(long)));
			}
			pe = ps+1;					// ready for next expression
			pos = strcspn(pe,";\t\n");
			ps = pe+pos;
			*ps = '\0';					// sets separator to null term.
			ind = ind + pos +1;
			exp.set_string(pe);			// set macro string to pe-ps
			values[count] = (float) exp.resolve(this);
			count++;
		} while (ind < len);
	} while (len == LINE_LEN);
	file.Close();
	return values;
}

// This function is called by the a view's Generate member. 
void CCGMScriptDoc::Generate(void)
{
	int i=0,max;
	
	// Get index of last script item.
	max = m_ElemArray.GetSize()-1;

	// This is the main processing loop. max is set to the index 
	// of the last element in the array. 
	for(i=0;i <= max ;i++) 
	{
		// Execute element only if not commented
		if (!((CMFElem*) m_ElemArray[i])->b_Comment) {
			((CMFElem*) m_ElemArray[i])->Generate(this);
		}
	}
	// Delete global variables if any are left in the list
	POSITION pos = m_VarList.GetHeadPosition();
	while (pos != NULL)	{
		CMacro* p;
		p = (CMacro *) m_VarList.RemoveHead();
		delete p;
		pos = m_VarList.GetHeadPosition();
	}
}
