// CGMScriptView.cpp : implementation of the CCGMScriptView class
//

#include "stdafx.h"
#include "CGMScript.h"

#include "Foreman.h"
#include "CGMScriptDoc.h"
#include "CGMScriptView.h"
#include "Task.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCGMScriptView

IMPLEMENT_DYNCREATE(CCGMScriptView, CFormView)

BEGIN_MESSAGE_MAP(CCGMScriptView, CFormView)
	//{{AFX_MSG_MAP(CCGMScriptView)
	ON_WM_SIZE()
	ON_NOTIFY(TVN_ITEMEXPANDING, IDC_ELEMTREE, OnItemexpandingElemtree)
	ON_NOTIFY(NM_DBLCLK, IDC_ELEMTREE, OnDblclkElemtree)
	ON_LBN_DBLCLK(IDC_SCRIPT, OnDblclkScript)
	ON_COMMAND(ID_CMT_BTN, OnCmtBtn)
	ON_UPDATE_COMMAND_UI(ID_CMT_BTN, OnUpdateCmtBtn)
	ON_COMMAND(ID_DEL_BTN, OnDelBtn)
	ON_UPDATE_COMMAND_UI(ID_DEL_BTN, OnUpdateDelBtn)
	ON_COMMAND(ID_EDT_BTN, OnEdtBtn)
	ON_UPDATE_COMMAND_UI(ID_EDT_BTN, OnUpdateEdtBtn)
	ON_COMMAND(ID_IND_BTN, OnIndBtn)
	ON_UPDATE_COMMAND_UI(ID_IND_BTN, OnUpdateIndBtn)
	ON_COMMAND(ID_UND_BTN, OnUndBtn)
	ON_UPDATE_COMMAND_UI(ID_UND_BTN, OnUpdateUndBtn)
	ON_COMMAND(ID_GEN_BTN, OnGenBtn)
	ON_UPDATE_COMMAND_UI(ID_GEN_BTN, OnUpdateGenBtn)
	ON_COMMAND(ID_EDIT_COM, OnEditCom)
	ON_UPDATE_COMMAND_UI(ID_EDIT_COM, OnUpdateEditCom)
	ON_COMMAND(ID_EDIT_DEL, OnEditDel)
	ON_UPDATE_COMMAND_UI(ID_EDIT_DEL, OnUpdateEditDel)
	ON_COMMAND(ID_EDIT_GEN, OnEditGen)
	ON_UPDATE_COMMAND_UI(ID_EDIT_GEN, OnUpdateEditGen)
	ON_COMMAND(ID_EDIT_IND, OnEditInd)
	ON_UPDATE_COMMAND_UI(ID_EDIT_IND, OnUpdateEditInd)
	ON_COMMAND(ID_EDIT_UND, OnEditUnd)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UND, OnUpdateEditUnd)
	ON_COMMAND(ID_ADD_BTN, OnAddBtn)
	ON_UPDATE_COMMAND_UI(ID_ADD_BTN, OnUpdateAddBtn)
	ON_COMMAND(ID_EDIT_UNDO, OnEditUndo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_UNDO, OnUpdateEditUndo)
	ON_COMMAND(ID_EDIT_REDO, OnEditRedo)
	ON_UPDATE_COMMAND_UI(ID_EDIT_REDO, OnUpdateEditRedo)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CFormView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CFormView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCGMScriptView construction/destruction

CCGMScriptView::CCGMScriptView()
	: CFormView(CCGMScriptView::IDD)
{
	//{{AFX_DATA_INIT(CCGMScriptView)
	//}}AFX_DATA_INIT
}

void CCGMScriptView::DoDataExchange(CDataExchange* pDX)
{
	CFormView::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCGMScriptView)
	//}}AFX_DATA_MAP
}

BOOL CCGMScriptView::PreCreateWindow(CREATESTRUCT& cs)
{
	// Modify the Window class or styles here by modifying the CREATESTRUCT cs
	return CFormView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CCGMScriptView printing

BOOL CCGMScriptView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	CCGMScriptDoc* pDoc = GetDocument();
    pInfo->SetMaxPage(pDoc->m_ElemArray.GetUpperBound() /
                      CCGMScriptDoc::nLinesPerPage + 1);
    return DoPreparePrinting(pInfo);
}

void CCGMScriptView::OnPrint(CDC* pDC, CPrintInfo* pInfo)
{
	int i,     nStart, nEnd, nHeight;
    CString    str = "CGMScript Listing";
    CPoint     point(0,0);
	// 1 INCH = 1440 TWIPS 
    CPoint     fpoint(0, -15120); // footer: 10.5 inches down
	CFont      font;
    TEXTMETRIC tm;
	
    pDC->SetMapMode(MM_TWIPS);
    CCGMScriptDoc* pDoc = GetDocument();
    m_nPage = pInfo->m_nCurPage; // for PrintPageFooters benefit
    nStart = (m_nPage - 1) * CCGMScriptDoc::nLinesPerPage;
    nEnd = nStart + CCGMScriptDoc::nLinesPerPage;
    // 8-point fixed-pitch font
    font.CreateFont(-160, 0, 0, 0, FW_NORMAL, FALSE, FALSE,
                    0, ANSI_CHARSET, OUT_DEFAULT_PRECIS,
                    CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY,
                    DEFAULT_PITCH | FF_MODERN, "Courier New");
                    // Courier New is a TrueType font
    CFont* pOldFont = (CFont*) (pDC->SelectObject(&font));
	// Page header
	pDC->TextOut(point.x, point.y, str);
	// Body
	point += CSize(720,-1440);	// 1/2 inch margin, 1 inch down
    pDC->GetTextMetrics(&tm);
    nHeight = tm.tmHeight + tm.tmExternalLeading;
    for (i = nStart; i < nEnd; i++) {
      if (i > pDoc->m_ElemArray.GetUpperBound())
        break;
      str.Format("%s", ((CMFElem*) pDoc->m_ElemArray[i])->GetString());
      point.y -= nHeight;
      pDC->TextOut(point.x, point.y, str);
    }
	// Footer
    str.Format("Document %s", (LPCSTR) pDoc->GetTitle());
    pDC->TextOut(fpoint.x, fpoint.y, str);
    str.Format("Page %d", m_nPage);
    CSize size = pDC->GetTextExtent(str);
    fpoint.x += 11520 - size.cx;	// 10.5 inches to right
    pDC->TextOut(fpoint.x, fpoint.y, str); // right-justified
	// Clean-up
	pDC->SelectObject(pOldFont);
}

/////////////////////////////////////////////////////////////////////////////
// CCGMScriptView diagnostics

#ifdef _DEBUG
void CCGMScriptView::AssertValid() const
{
	CFormView::AssertValid();
}

void CCGMScriptView::Dump(CDumpContext& dc) const
{
	CFormView::Dump(dc);
}

CCGMScriptDoc* CCGMScriptView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCGMScriptDoc)));
	return (CCGMScriptDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCGMScriptView message handlers

void CCGMScriptView::OnInitialUpdate() 
{
	// OnInitialUpdate takes care of subclassing the Colour List and 
	// Tree controls from the Dialog Resource to the CColrList and CElemTree
	// classes. It loads the resource icons into the image list for the 
	// tree control and initializes the tree control with element strings.
	
	int i;
	TV_INSERTSTRUCT tvinsert;
	CCGMScriptDoc*	pDoc = GetDocument();
	CRuntimeClass* root = Elements[0].pRTCElem;
	
	// This call registers the view to the framework for OLE message passing.
	// The OLE messages for Drag & Drop are first passed to the m_OleTarget
	// object which in turn passes them to the View. Done only once.
	if (m_ElemTree.m_hWnd == NULL)	// m_hWnd protected in COleDropTarget !
		m_OleTarget.Register(this);

	// Subclasses Controls for the Element Tree and Item List
	if (m_ElemTree.m_hWnd == NULL)
		m_ElemTree.SubclassDlgItem(IDC_ELEMTREE,this);
	if (m_ItemList.m_hWnd == NULL)
		m_ItemList.SubclassDlgItem(IDC_SCRIPT,this);

	/* If not yet done, add elements to the Element Tree */
	if (m_ImageList.m_hImageList == NULL) {
		// Set up the icon list
		m_ImageList.Create(16,16, TRUE, 0,4);
		m_ImageList.Add(AfxGetApp()->LoadIcon(IDI_FOLDER));		// Regular Folder
		m_ImageList.Add(AfxGetApp()->LoadIcon(IDI_S_FOLDER));	// Selected Folder
		m_ImageList.Add(AfxGetApp()->LoadIcon(IDI_ELEM));		// Regular Element
		m_ImageList.Add(AfxGetApp()->LoadIcon(IDI_S_ELEM));		// Selected Element
		m_ElemTree.SetImageList(&m_ImageList, TVSIL_NORMAL);
		// Initialize common values in structure
		tvinsert.hInsertAfter = TVI_LAST;
		tvinsert.item.mask = TVIF_IMAGE | TVIF_SELECTEDIMAGE | TVIF_TEXT;
		tvinsert.item.hItem = NULL;
		tvinsert.item.state = 0;
		tvinsert.item.stateMask = 0;
		tvinsert.item.cchTextMax = 6;
		tvinsert.item.cChildren = 0;
		tvinsert.item.lParam = 0;
		// For each element, set up individual values in structure
		for(i=0;i<NUM_ELEM;i++) {	
			static HTREEITEM hParent;
			if (Elements[i].nId == -1)	{	// Parent node
				tvinsert.hParent = NULL;	
				tvinsert.item.pszText = Elements[i].lpszName;	// Item String
				tvinsert.item.iImage = 0;			// Item icon from image list
				tvinsert.item.iSelectedImage = 0;	// 0= Regular Folder
				hParent = m_ElemTree.InsertItem(&tvinsert);
			}
			else	{
				tvinsert.hParent = hParent;	// Child node
				tvinsert.item.pszText = Elements[i].lpszName;
				tvinsert.item.iImage = 2;			// Item icon from image list
				if (Elements[i].pRTCElem != root) 
					tvinsert.item.iSelectedImage = 2;	// Valid Element
				else 
					tvinsert.item.iSelectedImage = 3;	// Incomplete Element
				m_ElemTree.InsertItem(&tvinsert);
			}
		}
	}

	// Set the view data members from the document
	UpdateData(FALSE);		// Update controls from data members
	CFormView::OnInitialUpdate();
}

void CCGMScriptView::OnSize(UINT nType, int cx, int cy) 
{
	// FYI: OnSize is called several times at startup and every time 
	// the main window is resized.
	// This code calculates the sizes of the 2 major controls and
	// places them in the client area.
	CRect rect;
	int margin=10;	// Margin width around edges
	int space=20;	// Amount of space between tree and list
	int width=160;	// Width of the tree
	int header=60;	// Space on top of the frame
	
	CFormView::OnSize(nType, cx, cy);
	GetClientRect(rect);
	// Positions the controls in the client area
	// IsWindow call is necessary when OnSize called before creation
	if (::IsWindow(m_ElemTree))
		m_ElemTree.SetWindowPos(&wndTop,
		margin,	header,	margin+width, rect.bottom-rect.top-header-margin,
		SWP_SHOWWINDOW | SWP_DRAWFRAME);
	if (::IsWindow(m_ItemList))
		m_ItemList.SetWindowPos(&wndTop,
		margin+width+space, header, 
		rect.right-rect.left-margin-margin-space-width, rect.bottom-rect.top-header-margin,
		SWP_SHOWWINDOW | SWP_DRAWFRAME);
}


/////////////////////////////////////////////////////////////////////////////
// CCGMScriptView Utilities

// Called by OnUpdate to recreate the Edit List
void CCGMScriptView::UpdateList(CCGMScriptDoc*	pDoc,BOOL bDoRedo,CTask* pTask)
{
	// For efficiency, we inspect the Task to decide
	// what needs to be done. If no task was passed, 
	// we recreate the whole list.
	int i, len=0;
	CObArray& m_ElemArray = pDoc->m_ElemArray;
	if (pTask != NULL) {
		if (pTask->IsKindOf( RUNTIME_CLASS( CDelElemTask ) )) {
			if (bDoRedo) m_ItemList.DeleteString(pTask->m_Pos);
			else m_ItemList.InsertString(pTask->m_Pos,((CMFElem*) m_ElemArray[pTask->m_Pos])->GetString());
		}
		else if (pTask->IsKindOf( RUNTIME_CLASS( CAddElemTask ) )) {
			if (!bDoRedo) m_ItemList.DeleteString(pTask->m_Pos);
			else m_ItemList.InsertString(pTask->m_Pos,((CMFElem*) m_ElemArray[pTask->m_Pos])->GetString());
		}
		else if (pTask->IsKindOf( RUNTIME_CLASS( CModElemTask ) )) {
			m_ItemList.DeleteString(pTask->m_Pos);
			m_ItemList.InsertString(pTask->m_Pos,((CMFElem*) m_ElemArray[pTask->m_Pos])->GetString());
		}
	}
	else {
		// Fill Item List from Document's Object Array !
		m_ItemList.ResetContent();					// Empty the CListBox
		len = m_ElemArray.GetUpperBound();			// Get actual array size
		for(i=0;i<=len;i++)							// Add each element
			m_ItemList.AddString(((CMFElem*) m_ElemArray[i])->GetString());
	}
	return;
}

void CCGMScriptView::AddElem(int i, BOOL where = TRUE)
{
	// Called from several places, this function creates
	// new elements dynamically, opens their Dialog Box for editing
	// then adds them or inserts them in the document.
	CCGMScriptDoc* pDoc = GetDocument();
	// Create the object dynamically
	CRuntimeClass* pRTCElem = Elements[i].pRTCElem;	// pointer to class ctor
	CObject* pMFElem = pRTCElem->CreateObject();	// create pointer to object
	TRACE("Created object of class: %s\n",pMFElem->GetRuntimeClass()->m_lpszClassName);
	
	// Open the object's dialog
	if (((CDialog *) pMFElem)->DoModal() == IDCANCEL)
		delete pMFElem;		// Don't forget to delete the object when Dlg is cancelled
	else {	// Dialog returned IDOK, store the info.
		int index;
		if (m_ItemList.GetSelCount() > 1) {
			AfxMessageBox(IDS_EDIT_SELERR,MB_ICONEXCLAMATION | MB_OK);
			return;
		}
		// Get first selected item or default to top
		if (!m_ItemList.GetSelItems(1,&index)) index = -1;
		m_ItemList.SetSel(index,FALSE);	// Unselect the old item
		if (where)		// Insert *before* current selection
			SubmitTask(new CAddElemTask(index,(CMFElem *) pMFElem, "Insert"));
		else			// Insert *after* current selection
			SubmitTask(new CAddElemTask(index+1,(CMFElem *) pMFElem, "Add"));
		m_ItemList.SetSel(index,TRUE);	// Select the new item
	}
}

// Delete Element action
inline void CCGMScriptView::DelElem(int i)
	{ SubmitTask(new CDelElemTask(i)); }

// Edit Element action
void CCGMScriptView::EditElem(int i)
{
	CCGMScriptDoc* pDoc = GetDocument();
	// Create a copy of pElem1 into pElem2.
	CMFElem* pElem1 = (CMFElem*) pDoc->m_ElemArray[i];
	CRuntimeClass* pRTC = pElem1->GetRuntimeClass();
	CMFElem* pElem2 = (CMFElem*) pRTC->CreateObject();
	*pElem2 = *pElem1;
	// Open the object's dialog
	if (((CDialog *) pElem2)->DoModal() == IDOK) {
		SubmitTask(new CModElemTask(i, pElem2, "Edit"));
	}
}

// Comment Selection
void CCGMScriptView::Comment() {
	int num,i;
	int* buf;
	int* ind;

	CCGMScriptDoc* pDoc = GetDocument();
	// Get number of items selected
	num = m_ItemList.GetSelCount();
	if (num == 0) {
		AfxMessageBox(IDS_EDIT_NOSEL,MB_ICONEXCLAMATION | MB_OK);
		return;
	}
	buf = (int* ) malloc(num * sizeof(int));	// allocate buffer
	ind = buf;									// copy address
	m_ItemList.GetSelItems(num,buf);
	// Iterate over the array.
	for(i=0;i<num;i++,ind++) {
		// Create a copy of pElem1 into pElem2.
		CMFElem* pElem1 = (CMFElem*) pDoc->m_ElemArray[*ind];
		CRuntimeClass* pRTC = pElem1->GetRuntimeClass();
		CMFElem* pElem2 = (CMFElem*) pRTC->CreateObject();
		*pElem2 = *pElem1;
		((CMFElem*) pElem2)->b_Comment = !(((CMFElem*) pElem2)->b_Comment);
		// Swap element in array with element passes to Task
		SubmitTask(new CModElemTask(*ind, pElem2, "Comment"));
	}
	// Reselect items
	ind = buf;
	for(i=0;i<num;i++,ind++)
		m_ItemList.SetSel(*ind);
	free(buf);
}

// Indent Selection
void CCGMScriptView::Indent() {
	int num,i;
	int* buf;
	int* ind;

	CCGMScriptDoc* pDoc = GetDocument();
	// Get number of items selected
	num = m_ItemList.GetSelCount();
	if (num == 0) {
		AfxMessageBox(IDS_EDIT_NOSEL,MB_ICONEXCLAMATION | MB_OK);
		return;
	}
	buf = (int* ) malloc(num * sizeof(int));	// allocate buffer
	ind = buf;									// copy address
	m_ItemList.GetSelItems(num,buf);
	// Iterate over the array.
	for(i=0;i<num;i++,ind++) {
		// Create a copy of pElem1 into pElem2.
		CMFElem* pElem1 = (CMFElem*) pDoc->m_ElemArray[*ind];
		CRuntimeClass* pRTC = pElem1->GetRuntimeClass();
		CMFElem* pElem2 = (CMFElem*) pRTC->CreateObject();
		*pElem2 = *pElem1;
		if (((CMFElem*) pElem2)->n_Indent < MAX_INDENT)
			((CMFElem*) pElem2)->n_Indent++;
		SubmitTask(new CModElemTask(*ind, pElem2, "Indent"));
	}
	// Reselect items
	ind = buf;
	for(i=0;i<num;i++,ind++)
		m_ItemList.SetSel(*ind);
	free(buf);
}

// Outdent Selection
void CCGMScriptView::Undent() {
	int num,i;
	int* buf;
	int* ind;

	CCGMScriptDoc* pDoc = GetDocument();
	// Get number of items selected
	num = m_ItemList.GetSelCount();
	if (num == 0) {
		AfxMessageBox(IDS_EDIT_NOSEL,MB_ICONEXCLAMATION | MB_OK);
		return;
	}
	buf = (int* ) malloc(num * sizeof(int));	// allocate buffer
	ind = buf;									// copy address
	m_ItemList.GetSelItems(num,buf);
	// Iterate over the array.
	for(i=0;i<num;i++,ind++) {
		// Create a copy of pElem1 into pElem2.
		CMFElem* pElem1 = (CMFElem*) pDoc->m_ElemArray[*ind];
		CRuntimeClass* pRTC = pElem1->GetRuntimeClass();
		CMFElem* pElem2 = (CMFElem*) pRTC->CreateObject();
		*pElem2 = *pElem1;
		if (((CMFElem*) pElem2)->n_Indent > 0)
			((CMFElem*) pElem2)->n_Indent--;
		SubmitTask(new CModElemTask(*ind, pElem2, "Outdent"));		
	}
	// Reselect items
	ind = buf;
	for(i=0;i<num;i++,ind++)
		m_ItemList.SetSel(*ind);
	free(buf);
}

// Delete Selection
void CCGMScriptView::Delete() {
	int num,i;
	int* buf;
	int* ind;

	CCGMScriptDoc* pDoc = GetDocument();
	// Get number of items selected
	num = m_ItemList.GetSelCount();
	if (num == 0) {
		AfxMessageBox(IDS_EDIT_NOSEL,MB_ICONEXCLAMATION | MB_OK);
		return;
	}
	buf = (int* ) malloc(num * sizeof(int));	// allocate buffer
	ind = buf;									// copy address
	m_ItemList.GetSelItems(num,buf);
	// Iterate over the array.
	ind += num-1;	// Get last element in the list
	for(i=0;i<num;i++,ind--)	// Delete from last to first
		DelElem(*ind);
	free(buf);
}

// Generate CGM File
void CCGMScriptView::Generate() {
	int i=0,num;
	
	CCGMScriptDoc* pDoc = GetDocument();
	// Get number of items selected
	num = m_ItemList.GetCount();
	if (num == 0) {
		AfxMessageBox(IDS_EDIT_NOSEL,MB_ICONEXCLAMATION | MB_OK);
		return;
	}
	pDoc->Generate();	// yep it's that easy !
}


// Edit Selection
void CCGMScriptView::EditSel() {
	int num,buf;

	CCGMScriptDoc* pDoc = GetDocument();
	// Get number of items selected
	num = m_ItemList.GetSelCount();
	if (num != 1) {
		AfxMessageBox(IDS_EDIT_BADSEL,MB_ICONEXCLAMATION | MB_OK);
		return;
	}
	m_ItemList.GetSelItems(1,&buf);
	EditElem(buf);
}


/////////////////////////////////////////////////////////////////////////////
// CCGMScriptView reflected messages handlers

void CCGMScriptView::OnItemexpandingElemtree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// Reflected message from the Tree Control.
	// Whenever a tree item is expanded or collapsed, the appropriate
	// folder image is selected.
	NM_TREEVIEW* pNMTreeView = (NM_TREEVIEW*)pNMHDR;
	// Change the image to Open?Closed folder
	if (pNMTreeView->itemNew.iImage == 0)
		m_ElemTree.SetItemImage(pNMTreeView->itemNew.hItem,1,1); // Open 
	else
		m_ElemTree.SetItemImage(pNMTreeView->itemNew.hItem,0,0); // Closed
	*pResult = 0;
}

void CCGMScriptView::OnDblclkElemtree(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// Reflected message from the Tree Control.
	int i=0;
	// When an Tree item is double-clicked a Script item must be created. 
	// Get the Item selected 
	HTREEITEM tItem = m_ElemTree.GetSelectedItem();
	// Check that it's a child node
	if (! m_ElemTree.GetChildItem(tItem)) {
		CString s1 = m_ElemTree.GetItemText(tItem);
		// Find index of this string in Elements table
		for(i=0;i<NUM_ELEM;i++) {
			CString s2(Elements[i].lpszName);
			if (s1.CompareNoCase(s2) == 0) break;
		}
		AddElem(i,FALSE);	// Insert Element *after* current selection
	}
	*pResult = 0;
}

void CCGMScriptView::OnDblclkScript() 
{
	int index;
	if (m_ItemList.GetSelCount() != 1) {
		MessageBox("Cannot edit multiple items !","Warning",MB_ICONEXCLAMATION | MB_OK);
		return;
	}
	m_ItemList.GetSelItems(1,&index);
	EditElem(index);
}


/////////////////////////////////////////////////////////////////////////////
// CCGMScriptView Menus and Buttons handlers


// Update Comment Button
void CCGMScriptView::OnUpdateCmtBtn(CCmdUI* pCmdUI)	
{
	if (m_ItemList.GetSelCount() != 0)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}

// Update Delete Button
void CCGMScriptView::OnUpdateDelBtn(CCmdUI* pCmdUI) 
{
	if (m_ItemList.GetSelCount() != 0)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}

// Update Duplicate Button
void CCGMScriptView::OnUpdateEdtBtn(CCmdUI* pCmdUI) 
{
	if (m_ItemList.GetSelCount() != 1)
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable(TRUE);	
}

// Update Indent Button
void CCGMScriptView::OnUpdateIndBtn(CCmdUI* pCmdUI) 
{
	if (m_ItemList.GetSelCount() != 0)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);	
}

// Update Outdent Button
void CCGMScriptView::OnUpdateUndBtn(CCmdUI* pCmdUI) 
{
	if (m_ItemList.GetSelCount() != 0)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);	
}

// Update Generate Button
void CCGMScriptView::OnUpdateGenBtn(CCmdUI* pCmdUI) 
{
	if (m_ItemList.GetCount() != 0)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}

// Update Add Button
void CCGMScriptView::OnUpdateAddBtn(CCmdUI* pCmdUI) 
{
	HTREEITEM tItem = m_ElemTree.GetSelectedItem();
	// Check that it's a child node
	if ((tItem != NULL) &&
		(m_ItemList.GetSelCount() == 1) && 
		(!m_ElemTree.GetChildItem(tItem)) )
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);		
}

// Update Comment Menu
void CCGMScriptView::OnUpdateEditCom(CCmdUI* pCmdUI) 
{
	if (m_ItemList.GetSelCount() != 0)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}

// Update Delete Menu
void CCGMScriptView::OnUpdateEditDel(CCmdUI* pCmdUI) 
{
	if (m_ItemList.GetSelCount() != 1)
		pCmdUI->Enable(FALSE);
	else
		pCmdUI->Enable(TRUE);
}

// Update Generate Menu
void CCGMScriptView::OnUpdateEditGen(CCmdUI* pCmdUI) 
{
	if (m_ItemList.GetCount() != 0)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);
}

// Update Indent Menu
void CCGMScriptView::OnUpdateEditInd(CCmdUI* pCmdUI) 
{
	if (m_ItemList.GetSelCount() != 0)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);	
}

// Update Outdent Menu
void CCGMScriptView::OnUpdateEditUnd(CCmdUI* pCmdUI) 
{
	if (m_ItemList.GetSelCount() != 0)
		pCmdUI->Enable(TRUE);
	else
		pCmdUI->Enable(FALSE);		
}

// Update Undo Menu
void CCGMScriptView::OnUpdateEditUndo(CCmdUI* pCmdUI) 
{
	CString str("Undo ");
	str = str + GetDocument()->m_Foreman.GetUndoDescription() + "\tCtrl+Z";
	pCmdUI->SetText(str);
	pCmdUI->Enable(GetDocument()->m_Foreman.CanUndo());
}

// Update Redo Menu
void CCGMScriptView::OnUpdateEditRedo(CCmdUI* pCmdUI) 
{
	CString str("Redo ");
	str = str + GetDocument()->m_Foreman.GetRedoDescription() + "\tCtrl+A";
	pCmdUI->SetText(str);
	pCmdUI->Enable(GetDocument()->m_Foreman.CanRedo());
}

// Add button action
void CCGMScriptView::OnAddBtn() 
{
	int i=0;
	// Get the Item selected 
	HTREEITEM tItem = m_ElemTree.GetSelectedItem();
	// Check that it's a child node
	if (! m_ElemTree.GetChildItem(tItem)) {
		CString s1 = m_ElemTree.GetItemText(tItem);
		// Find index of this string in Elements table
		for(i=0;i<NUM_ELEM;i++) {
			CString s2(Elements[i].lpszName);
			if (s1.CompareNoCase(s2) == 0) break;
		}
		AddElem(i,TRUE);	// Insert Element *before* current selection
	}
}

