// MFElem.cpp : implementation file
//

#include "stdafx.h"
#include "CGMScript.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMFElem dialog


CMFElem::CMFElem(CWnd* pParent /*=NULL*/)
	: CDialog(CMFElem::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMFElem)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	n_Indent = 0;	// Initial indent
	b_Comment = 0;
}

CMFElem::CMFElem(UINT dId, CWnd* pParent /*=NULL*/)
	: CDialog(dId, pParent)
{
	n_Indent = 0;	// Initial indent
	b_Comment = 0;
}


void CMFElem::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMFElem)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

IMPLEMENT_SERIAL(CMFElem, CDialog, 1)

BEGIN_MESSAGE_MAP(CMFElem, CDialog)
	//{{AFX_MSG_MAP(CMFElem)
		// NOTE: the ClassWizard will add message map macros here
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMFElem message handlers

void CMFElem::Serialize(CArchive& ar) 
{
	// Derived classes should override this member function
	if (ar.IsStoring())
	{	// storing code
		ar << (LONG) n_Indent << b_Comment;
	}
	else
	{	// loading code
		ar >> (LONG&) n_Indent >> b_Comment;
	}
}

int CMFElem::DoModal() 
{
	// Derived classes should override this member function
	// only if they plan to do something special before 
	// the dialog is displayed.
	return CDialog::DoModal();
}

CString CMFElem::GetString()
{
	int i;
	// Derived classes should call their parent to benefit
	// from the colouring and formatting for comments and indent.
	// Start the string with a digit to get a colour. (resource.h)
	CString s;
	if (b_Comment) s = "0// ";
	for(i=0;i<n_Indent;i++)	s += "    ";
#ifdef _DEBUG
	s = s + (CString) "Class: ";
	s = s + (CString) this->GetRuntimeClass()->m_lpszClassName;
	s = s + ": ";
#endif _DEBUG
	return s;
}

long CMFElem::Generate(CCGMScriptDoc *pDoc)
{
	// Derived classes should override this member function
	// returning the result of MDLG Calls
	TRACE("Generated Element: %s\n",(CString) this->GetString());
	return 0;
}

CMFElem& CMFElem::operator=(const CMFElem& elRHS)
{
	b_Comment = elRHS.b_Comment;
	n_Indent = elRHS.n_Indent;
	return *this;
}
