// CGMScriptDoc.h : interface of the CCGMScriptDoc class
//
/////////////////////////////////////////////////////////////////////////////
class CMacro;

class CCGMScriptDoc : public CDocument
{
protected: // create from serialization only
	CCGMScriptDoc();
	DECLARE_DYNCREATE(CCGMScriptDoc)

// Attributes
public:
	enum { nLinesPerPage = 75 };
	CObArray	m_ElemArray;	// CMFElem Array
	CForeman	m_Foreman;		// Script Undo/Redo manager
	CObList		m_VarList;		// Global Variables 
	
// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CCGMScriptDoc)
	public:
	virtual void Serialize(CArchive& ar);
	virtual void DeleteContents();
	virtual BOOL OnSaveDocument(LPCTSTR lpszPathName);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CCGMScriptDoc()	{ /* empty */ }
	void Generate();			// CGM File generation
	CMacro* FindByName(const char *,int);
	long* GetLongsFromFile(CString s,long &count);
	float* GetFloatsFromFile(CString s,long &count);

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CCGMScriptDoc)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
UINT GenerateThreadProc(LPVOID pParam);	// Generate Thread declaration
