/////////////////////////////////////////////////////////////////////////////
// Element Classes, all derived from CMFElem
#include "yyleo.h"

/////////////////////////////////////////////////////////////////////////////
// ECBegin dialog
class ECBegin : public CMFElem
{
// Construction
public:
	ECBegin(CWnd* pParent = NULL);   // standard constructor
	DECLARE_SERIAL(ECBegin)

// Dialog Data
	//{{AFX_DATA(ECBegin)
	enum { IDD = IDD_BEGIN };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

// Implementation
public:
	virtual CString GetString();	// For display
	virtual long Generate(CCGMScriptDoc *);	// For generation
	virtual CMFElem& operator=(const CMFElem&);	// For Undo/Redo

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ECBegin)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(ECBegin)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// ECEnd dialog

class ECEnd : public CMFElem
{
// Construction
public:
	ECEnd(CWnd* pParent = NULL);   // standard constructor
	DECLARE_SERIAL(ECEnd)

// Dialog Data
	//{{AFX_DATA(ECEnd)
	enum { IDD = IDD_END };
	//}}AFX_DATA

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ECEnd)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual CString GetString();	// For display
	virtual long Generate(CCGMScriptDoc *);	// For generation
	virtual CMFElem& operator=(const CMFElem&);	// For Undo/Redo

protected:

	// Generated message map functions
	//{{AFX_MSG(ECEnd)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// ECLoop dialog
class ECLoop : public CMFElem
{
// Construction
public:
	ECLoop(CWnd* pParent = NULL);   // standard constructor
	DECLARE_SERIAL(ECLoop)

// Dialog Data
	//{{AFX_DATA(ECLoop)
	enum { IDD = IDD_LOOP };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ECLoop)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual CString GetString();	// For display
	virtual long Generate(CCGMScriptDoc *);	// For generation
	virtual CMFElem& operator=(const CMFElem&);	// For Undo/Redo

protected:
	// Generated message map functions
	//{{AFX_MSG(ECLoop)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
// ECAbort dialog
class ECAbort : public CMFElem
{
// Construction
public:
	ECAbort(CWnd* pParent = NULL);   // standard constructor
	DECLARE_SERIAL(ECAbort)


// Dialog Data
	//{{AFX_DATA(ECAbort)
	enum { IDD = IDD_ABORT };
	//}}AFX_DATA

// Implementation
public:
	virtual CString GetString();	// For display
	virtual long Generate(CCGMScriptDoc *);	// For generation
	virtual CMFElem& operator=(const CMFElem&);	// For Undo/Redo

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ECAbort)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(ECAbort)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// ECRectangle dialog

class ECRectangle : public CMFElem
{
// Construction
public:
	ECRectangle(CWnd* pParent = NULL);   // standard constructor
	DECLARE_SERIAL(ECRectangle)

// Dialog Data
	//{{AFX_DATA(ECRectangle)
	enum { IDD = IDD_RECTANGLE };
	CMacro	m_P1x;
	CMacro	m_P1y;
	CMacro	m_P2x;
	CMacro	m_P2y;
	//}}AFX_DATA

// Implementation
public:
	virtual CString GetString();	// For display
	virtual long Generate(CCGMScriptDoc *);	// For generation
	virtual CMFElem& operator=(const CMFElem&);	// For Undo/Redo

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ECRectangle)
	public:
	virtual void Serialize(CArchive& ar);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(ECRectangle)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
/////////////////////////////////////////////////////////////////////////////
// ECCircle dialog

class ECCircle : public CMFElem
{
// Construction
public:
	ECCircle(CWnd* pParent = NULL);   // standard constructor
	DECLARE_SERIAL(ECCircle)

// Dialog Data
	//{{AFX_DATA(ECCircle)
	enum { IDD = IDD_CIRCLE };
	CMacro	m_Px;
	CMacro	m_Py;
	CMacro	m_Radius;
	//}}AFX_DATA

// Implementation
public:
	virtual CString GetString();	// For display
	virtual long Generate(CCGMScriptDoc *);	// For generation
	virtual CMFElem& operator=(const CMFElem&);	// For Undo/Redo

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(ECCircle)
	public:
	virtual void Serialize(CArchive& ar);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(ECCircle)
		// NOTE: the ClassWizard will add member functions here
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
