// ExampleDlg.cpp : implementation file
// Copyright (C) 1998, John C. Schettino Jr.

#include "stdafx.h"
#include "Example.h"
#include "ExampleDlg.h"
#include "Wcedb.h"
#include "cedatabase.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg dialog

CExampleDlg::CExampleDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CExampleDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CExampleDlg)
	m_sf11 = _T("");
	m_sf12 = _T("");
	m_yy1 = 0;
	m_yy2 = 0;
	m_mm1 = 0;
	m_mm2 = 0;
	m_if1 = 0;
	m_if2 = 0;
	m_dd1 = 0;
	m_dd2 = 0;
	m_d11val = -1;
	m_d12val = -1;
	m_i11val = -1;
	m_i12val = -1;
	m_s11val = -1;
	m_s12val = -1;
	m_sortval = -1;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CExampleDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CExampleDlg)
	DDX_Control(pDX, IDC_SORT, m_sorttest);
	DDX_Control(pDX, IDC_D12TEST, m_d12test);
	DDX_Control(pDX, IDC_D11TEST, m_d11test);
	DDX_Control(pDX, IDC_I12TEST, m_i12test);
	DDX_Control(pDX, IDC_I11TEST, m_i11test);
	DDX_Control(pDX, IDC_S12TEST, m_s12test);
	DDX_Control(pDX, IDC_S11TEST, m_s11test);
	DDX_Text(pDX, IDC_SF11, m_sf11);
	DDX_Text(pDX, IDC_SF12, m_sf12);
	DDX_Text(pDX, IDC_YY1, m_yy1);
	DDX_Text(pDX, IDC_YY2, m_yy2);
	DDX_Text(pDX, IDC_MM1, m_mm1);
	DDX_Text(pDX, IDC_MM2, m_mm2);
	DDX_Text(pDX, IDC_IF11, m_if1);
	DDX_Text(pDX, IDC_IF12, m_if2);
	DDX_Text(pDX, IDC_DD1, m_dd1);
	DDX_Text(pDX, IDC_DD2, m_dd2);
	DDX_CBIndex(pDX, IDC_D11TEST, m_d11val);
	DDX_CBIndex(pDX, IDC_D12TEST, m_d12val);
	DDX_CBIndex(pDX, IDC_I11TEST, m_i11val);
	DDX_CBIndex(pDX, IDC_I12TEST, m_i12val);
	DDX_CBIndex(pDX, IDC_S11TEST, m_s11val);
	DDX_CBIndex(pDX, IDC_S12TEST, m_s12val);
	DDX_CBIndex(pDX, IDC_SORT, m_sortval);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CExampleDlg, CDialog)
	//{{AFX_MSG_MAP(CExampleDlg)
	ON_BN_CLICKED(IDC_Init, OnInit)
	ON_BN_CLICKED(IDC_BUTTON2, OnSearch)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static void
setupPicker(RECT *pr, CComboBox *p)
{
	RECT r;
	p->AddString(TEXT("LE"));
	p->AddString(TEXT("GE"));
	p->AddString(TEXT("EQ"));

	p->GetWindowRect(&r);
	r.top -= pr->top;
	r.left -= pr->left;
	r.right -= pr->left;
	r.bottom += 60;
	p->MoveWindow(&r);
}

static void
setupSort(RECT *pr, CComboBox *p)
{
	RECT r;
	p->AddString(TEXT("None"));
	p->AddString(TEXT("String"));
	p->AddString(TEXT("Int"));

	p->GetWindowRect(&r);
	r.top -= pr->top;
	r.left -= pr->left;
	r.right -= pr->left;
	r.bottom += 60;
	p->MoveWindow(&r);
}

/////////////////////////////////////////////////////////////////////////////
// CExampleDlg message handlers

BOOL CExampleDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// create 6 combo boxes for LT, GT, EQ tests
	RECT pr;
	GetClientRect(&pr);
	ClientToScreen(&pr);
	setupPicker(&pr, &m_s11test);
	setupPicker(&pr, &m_s12test);
	setupPicker(&pr, &m_i11test);
	setupPicker(&pr, &m_i12test);
	setupPicker(&pr, &m_d11test);
	setupPicker(&pr, &m_d12test);
	setupSort(&pr, &m_sorttest);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CExampleDlg::OnInit() 
{
	// make a new database with three fields, indexed on string and int field
	// populate with 1000 records
	CCeDBDatabase newDB;
	CCeDBProp sorts[2];

	sorts[0].SetType(CCeDBProp::Type_String);
	sorts[0].SetIdent(1);
	sorts[0].SetSortFlags(CCeDBProp::Sort_Ascending ); 
	sorts[1].SetType(CCeDBProp::Type_Long);
	sorts[1].SetIdent(2);
	sorts[1].SetSortFlags(CCeDBProp::Sort_Descending ); 

	if (newDB.Create(TEXT("JCSExample"), 123, 2, sorts) == NULL)
	{
		newDB.Open(TEXT("JCSExample")); 
		newDB.Delete();
		newDB.Create(TEXT("JCSExample"), 123, 2, sorts);
	}
	newDB.Open(TEXT("JCSExample")); 

	CCeDBRecord r; 
	r.AddProp(&sorts[0]);
	r.AddProp(&sorts[1]);
	r.AddProp(new CCeDBProp(CCeDBProp::Type_Filetime, 3));
	for (int i = 0; i < 1000; i++)
	{
		TCHAR string_field[256];
		FILETIME filetime_field;
		SYSTEMTIME systemTime;
		int j;

		// generate three random values for fields
		CCeDBProp* p = r.GetPropFromIdent(1);
		string_field[0] = (TCHAR)('A'+Random()%26);
		for (j=1; j < (int)(5 + (Random()%10)); j++)
			string_field[j] = (TCHAR)('a'+Random()%26);
		string_field[j] = 0;
		
		p->SetString(string_field);
		p = r.GetPropFromIdent(2);
		p->SetLong(Random());
		p = r.GetPropFromIdent(3);

		memset(&systemTime, 0, sizeof(systemTime));
		systemTime.wYear = (unsigned short) (1900 + Random()%200);
		systemTime.wMonth = (unsigned short) (1 + Random()%12);
		systemTime.wDay = (unsigned short) (1 + Random()%28);
		SystemTimeToFileTime(&systemTime, &filetime_field);
		p->SetFiletime(filetime_field);
		newDB.AddRecord(&r);
	}
}

void CExampleDlg::OnSearch() 
{
	if (!UpdateData(true)) return;

	FILETIME filetime_field;
	SYSTEMTIME t;

	CCeDBQueryProp::FieldOperation _ops[] = {
		CCeDBQueryProp::LE,
		CCeDBQueryProp::GE,
		CCeDBQueryProp::Equal};

	CCeDBQueryProp * qp;
	CEQuery q;

	// build seach critera
	if (m_s11val != -1 && !m_sf11.IsEmpty())
	{
		qp = new CCeDBQueryProp();
		qp->SetType(CCeDBProp::Type_String);
		qp->SetIdent(1);
		qp->SetString((TCHAR *)(LPCTSTR)m_sf11);
		qp->setOperation(_ops[m_s11val]);
		q.addField(qp);
	}
	if (m_s12val != -1 && !m_sf12.IsEmpty())
	{
		qp = new CCeDBQueryProp();
		qp->SetType(CCeDBProp::Type_String);
		qp->SetIdent(1);
		qp->SetString((TCHAR *)(LPCTSTR)m_sf12);
		qp->setOperation(_ops[m_s12val]);
		q.addField(qp);
	}
	if (m_i11val != -1)
	{
		qp = new CCeDBQueryProp();
		qp->SetType(CCeDBProp::Type_Long);
		qp->SetIdent(2);
		qp->SetLong(m_if1);
		qp->setOperation(_ops[m_i11val]);
		q.addField(qp);
	}
	if (m_i12val != -1)
	{
		qp = new CCeDBQueryProp();
		qp->SetType(CCeDBProp::Type_Long);
		qp->SetIdent(2);
		qp->SetLong(m_if2);
		qp->setOperation(_ops[m_i12val]);
		q.addField(qp);
	}
	if (m_d11val != -1 && m_mm1 != 0 && m_dd1 != 0 && m_yy1 != 0)
	{
		memset(&t, 0, sizeof(t));
		t.wYear = m_yy1;
		t.wMonth = m_mm1;
		t.wDay = m_dd1;
		if (SystemTimeToFileTime(&t, &filetime_field))
		{
			qp = new CCeDBQueryProp();
			qp->SetType(CCeDBProp::Type_Filetime);
			qp->SetIdent(3);
			qp->SetFiletime(filetime_field);
			qp->setOperation(_ops[m_d11val]);
			q.addField(qp);
		}
	}
	if (m_d12val != -1 && m_mm2 != 0 && m_dd2 != 0 && m_yy2 != 0)
	{
		memset(&t, 0, sizeof(t));
		t.wYear = m_yy2;
		t.wMonth = m_mm2;
		t.wDay = m_dd2;
		if (SystemTimeToFileTime(&t, &filetime_field))
		{
			qp = new CCeDBQueryProp();
			qp->SetType(CCeDBProp::Type_Filetime);
			qp->SetIdent(3);
			qp->SetFiletime(filetime_field);
			qp->setOperation(_ops[m_d12val]);
			q.addField(qp);
		}
	}

	if (m_sortval > 0)
	{
		qp = new CCeDBQueryProp();
		qp->SetIdent(m_sortval);
		q.setSortField(qp);
	}

	CCeFindDBDatabase theDB;
	theDB.Open(TEXT("JCSExample"));
	CCeFindDBDatabaseIterater *results = theDB.Find(q);

	TRACE0("\nResults:\n");
	for (CCeDBRecord *r = results->first(); r; r = results->next())
	{
			CCeDBProp* strfield = r->GetPropFromIdent(1);
			CCeDBProp* intfield = r->GetPropFromIdent(2);
			CCeDBProp* datefield = r->GetPropFromIdent(3);
			FILETIME f = (datefield->GetFiletime());
			SYSTEMTIME t;
			FileTimeToSystemTime(&f, &t);
			TCHAR timeStr[256];
			GetDateFormat(LOCALE_SYSTEM_DEFAULT, DATE_LONGDATE, &t, 0, timeStr, 256);

			TRACE3("\t%s\t%d\t%s\n", strfield->GetString(), intfield->GetLong(), timeStr);
			delete r;
	}

	int hits, tests;
	bool range;
	results->stats(hits, tests, range);
	TRACE3("Stats\n\tmatches: %d\n\tmisses: %d\n\tTotal: %d\n", hits, tests, hits+tests);
	TRACE1("Range search %s used\n", range ? TEXT("was") : TEXT("was not"));
}
