/* @#START#@
**
** Copyright:
**	(C) Copyright International Business Machines Corporation 1996
**	All Rights Reserved
**	Licensed Materials - Property of IBM
**	US Government Users Restricted Rights - Use, duplication, or disclosure
**	restricted by GSA ADP Schedule Contract with IBM Corp.               
**
** Module:
**	fma.h
**
** Description:
**	User defines for FMA
**
** Functions:
**
** Dependencies:
**
** Context:
**
** Restrictions:
**
** Environment:
**	AIX 4.1.4 with CSET++ 3.1.4
**
** Version:
**	%W% %I% %D% %T%
**
** History:
** Date       Author  Description
** -----------------------------------------------------------------------------
** 19-Nov-96  Richter Created
**
** @#END#@*/

#ifndef fma_h
#define	fma_h

#define	PREFETCH	0x1	/* Prefetch the pages in shared memory */
#define	SHARED		0x2	/* Create a new shared memory segment */
#define	ATTACH		0x4	/* Attach an already created shared mem seg */
#define	SYSTEM		0x8	/* Use Operating system heap */

/*
** Prototypes
*/
int fmadown();
int fmainit(size_t, int, char);
int fmalock(struct t_heapmgr *heapp);
int fmaunlock(struct t_heapmgr *heapp);
void *fmaalloc(unsigned long);
void fmafree(void *);

#endif
