/* @#START#@
**
** Copyright:
**	(C) Copyright International Business Machines Corporation 1996
**	All Rights Reserved
**	Licensed Materials - Property of IBM
**	US Government Users Restricted Rights - Use, duplication, or disclosure
**	restricted by GSA ADP Schedule Contract with IBM Corp.               
**
** Module:
**	fmacpp.H
**
** Description:
**	Header file for operator new and delete to support the FMA allocator
**
** Functions:
**
** Dependencies:
**
** Context:
**
** Restrictions:
**
** Environment:
**	AIX 4.1.4 with CSET++ 3.1.4
**
** Version:
**	%W% %I% %D% %T%
**
** History:
** Date       Author  Description
** -----------------------------------------------------------------------------
** 12-Jul-97  Richter Created
**
** @#END#@*/

#include	<iostream.h>
#include	"fmacpp.H"

void *operator new(unsigned long size)
{
    static int first_call;
    static int failed;

    if( first_call == 0 ){
	++first_call;
	int rc = fmainit(fmapolicy.size, fmapolicy.flags, fmapolicy.key);
	if( rc ){
	    cerr << "fmainit failed:" << rc << endl;
	    failed = 1;
	}
    }
    if( failed )
	return (void *)0;
    void *ptr = fmaalloc(size);
    cout << "FMA-new " << size << ", " << ptr << endl;
    return ptr;
}

void operator delete(void *addr)
{
    cout << "FMA-delete " << addr << endl;
    if( addr )
	fmafree(addr);
    if( fmapolicy.remove_now )
	fmadown();
}
