/* @#START#@
**
** Copyright:
**	(C) Copyright International Business Machines Corporation 1996
**	All Rights Reserved
**	Licensed Materials - Property of IBM
**	US Government Users Restricted Rights - Use, duplication, or disclosure
**	restricted by GSA ADP Schedule Contract with IBM Corp.               
**
** Module:
**	fmalock.c
**
** Description:
**	Memory allocation for FMA, locking functions
**
** Functions:
**
** Dependencies:
**
** Context:
**
** Restrictions:
**
** Environment:
**	AIX 4.1.2 with CSET++ 3.1.3
**
** Linkage:
**
** Entry points:
**
** Input:
**
** Output:
**
** Return:
**
** External references:
**
** Version:
**	%W% %I% %D% %T%
**
** History:
** Date       Author  Description
** -----------------------------------------------------------------------------
** 17-Jun-97  Richter Created
**
** @#END#@*/

#include	<sys/errno.h>
#include	<sys/ipc.h>
#include	<sys/types.h>
#include	<sys/sem.h>


#include	"fmaheap.h"

/*
** Lock the memory management for being shared by several processes.
** Return 0 for success and errno else
*/
int fmalock(struct t_heapmgr *heapp)
{
    struct sembuf sem;

    sem.sem_num = 0;
    sem.sem_op = -1;
    sem.sem_flg = SEM_UNDO;
    if( semop(heapp->semid, &sem, 1) == -1 )
	return errno;
    return 0;
}

int fmaunlock(struct t_heapmgr *heapp)
{
    struct sembuf sem;

    sem.sem_num = 0;
    sem.sem_op = 1;
    sem.sem_flg = SEM_UNDO;
    if( semop(heapp->semid, &sem, 1) == -1 )
	return errno;
    return 0;
}
