#include	<sys/types.h>
#include	<time.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	"ipalloc2.h"

#define ALLOCSIZE 500
static unsigned long alloc[ALLOCSIZE];
static unsigned long myfreelist[8];
/*                16    32    64    128   256  512  1024 2048 */
float dist[8] = { 0.10, 0.30, 0.30, 0.15, 0.06,0.05,0.02,0.02 };

static int roundup(int size)
{
    int idx;
    if( size <= 16 )
	idx = 0;
    else if( size <= 32 )
	idx = 1;
    else if( size <= 64 )
	idx = 2;
    else if( size <= 128 )
	idx = 3;
    else if( size <= 256 )
	idx = 4;
    else if( size <= 512 )
	idx = 5;
    else if( size <= 1024 )
	idx = 6;
    else if( size <= 2048 )
	idx = 7;
    return idx;
}

int main(int argc, char **argv)
{
    extern int optind;
    extern char *optarg;
    long seed = 0, maxmem = 1<<24;
    int no = 10, size;
    int i, j, ok, slot, maxslot = 0;
    
    while( (i = getopt(argc, argv, "s:m:d:")) != EOF )
	switch( i ){
	case 's':	seed = atol(optarg);
			break;
	case 'm':	maxmem = atol(optarg);
			break;
	default:
		fprintf(stderr, "usage: main [-sseed][-mmaxmem] [no]\n");
    }
    if( optind < argc )
	no = atoi(argv[optind++]);
    srand48(seed);
    for( i = 0; i < no; ++i){
	do {
	    size = lrand48() % 2048 + 1;
	    slot = roundup(size);
	}while( (float)myfreelist[slot] / no > dist[slot] );
	myfreelist[slot]++;

	for( j = 0; j < maxslot; ++j )
	    if( alloc[j] == 0 ){
		printf("a %4d %5d\n", size, j);
		alloc[j] = size;
		break;
	    }
	if( j == maxslot ){
	    if( maxslot == ALLOCSIZE ){
		int i1 = 0;
		for(; i1 < ALLOCSIZE; ++i1 )
		    printf("f           %5d %4d\n", i1, alloc[i1]);
		maxslot = 0;
	    }
	    printf("a %4d %5d\n", size, maxslot);
	    alloc[maxslot++] = size;
	}

	if( maxslot > 1 && size % 3 == 1 ){
	    j = size % 5;
	    for( ; --j >= 0 ; ){
		int idx = lrand48() % maxslot;
		if( alloc[idx] ){
		    printf("f           %5d %4d\n", idx, alloc[idx]);
		    alloc[idx] = 0;
		}
	    }
	}
    }
    for( i = 0 ; i < ALLOCSIZE; ++i ){
	if( alloc[i] ){
	    printf("f           %5d %4d\n", i, alloc[i]);
	}
    }
    for( i = 0 ; i < 8; ++i )
	printf("s(%d) %5d %4.2f\n", 16 << i, myfreelist[i], (float)myfreelist[i]/no);
}
